import { 
  select, 
  scaleLinear, 
  extent,
  axisLeft,
  axisBottom
} from 'd3';

export const scatterplot = (selection, props) => {const 
{data,circleRadius,colorScale,colorValue,selectedcountry,innerHeight, innerWidth
  } = props;
  
  const xValue = d => d.year;
  const xAxisLabel = 'Year';
  const yValue = d => d.gdp;
  const yAxisLabel = 'GDP (In Percent)';
  
  
     
   //x-axis configure                                             
  const xScale = scaleLinear()
    .domain(extent(data, xValue))
    .range([0, innerWidth])
    .nice();
  const xAxis = axisBottom(xScale)
    .ticks(10)
    .tickSize(-innerHeight)
    .tickPadding(10);
  
  const xAxisG = selection.append('g').call(xAxis)
    .attr('transform', `translate(0,${innerHeight})`);
  
  xAxisG.select('.domain').remove();
  
  xAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', 60)
      .attr('x', innerWidth / 2)
      .attr('fill', 'black')
      .text(xAxisLabel);
 
  
    //y-axis configure                                              
                                                  
  const yScale = scaleLinear()
    .domain(extent(data, yValue))
    .range([innerHeight, 0])
    .nice();
  
  
  const yAxis = axisLeft(yScale)
    .tickSize(-innerWidth)
    .tickPadding(5)
  
  const yAxisG = selection.append('g').call(yAxis);
  yAxisG.selectAll('.domain').remove();
  
  yAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', -55)
      .attr('x', -innerHeight / 2)
      .attr('fill', 'black')
      .attr('transform', `rotate(-90)`)
      .attr('text-anchor', 'middle')
      .text(yAxisLabel);
  
  
  
  //enter and merge     
                                                  
  const obs =selection.selectAll('.country').data(data);
                                                  
  const obsenter = obs.enter().append('circle')
      .attr('class', 'country')
      .attr('cy', d => yScale(yValue(d)))
      .attr('cx', d => xScale(xValue(d)))
      .attr('r', circleRadius) 
      .attr('fill', d => colorScale(d.country));
                                                  
   points
   .merge(obsenter)
   .attr('opacity', d =>(!selectedcountry || d.country === selectedcountry) ? 1 : 0.05);
};